"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const clear = require("clear");
const ink_1 = require("ink");
class Less extends ink_1.Component {
    constructor(props) {
        super(props);
        const contentLineLength = props.content.split('\n').length;
        this.state = {
            contentLineLength,
            rows: contentLineLength < props.rows ? contentLineLength : props.rows,
            scrollLine: 0,
        };
    }
    get viewableContent() {
        return this.props.content
            .split('\n')
            .concat(Array(this.state.rows).fill(''))
            .slice(this.state.scrollLine, this.state.scrollLine + this.state.rows)
            .join('\n');
    }
    render(props) {
        clear();
        return ink_1.h("div", null, this.viewableContent);
    }
    scroll(num) {
        this.setState({
            scrollLine: this.state.scrollLine + num,
        });
    }
    componentDidMount() {
        process.stdin.on('keypress', (ch, key) => __awaiter(this, void 0, void 0, function* () {
            if (!key) {
                return;
            }
            switch (key.name) {
                case 'j': {
                    if (this.state.scrollLine + this.state.rows + 1 <
                        this.state.contentLineLength) {
                        this.scroll(1);
                    }
                    break;
                }
                case 'k': {
                    if (this.state.scrollLine > 0) {
                        this.scroll(-1);
                    }
                    break;
                }
                case 'return' /* enter */:
                case 'y': {
                    yield this.props.save();
                    break;
                }
                case 'n': {
                    process.exit(0);
                    break;
                }
                default:
            }
        }));
    }
}
exports.Less = Less;
//# sourceMappingURL=less.js.map