"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk = require("chalk");
const fs = require("fs");
const util_1 = require("util");
function ensureFile(filename) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield util_1.promisify(fs.access)(filename, fs.constants.F_OK);
        }
        catch (_) {
            try {
                yield util_1.promisify(fs.writeFile)(filename, '');
            }
            catch (err) {
                // tslint:disable-next-line no-console
                console.error(chalk.red(err.message));
                process.exit(1);
            }
        }
    });
}
exports.ensureFile = ensureFile;
//# sourceMappingURL=ensure-file.js.map